From 80765206dcdc5e474cf49b92846a57b61c50e006 Mon Sep 17 00:00:00 2001
From: Amul Sul <sulamul@gmail.com>
Date: Tue, 15 Apr 2025 09:42:52 +0530
Subject: [PATCH] pg_combinebackup: Fix incorrect code comment.

The comment in the process_directory_recursively() prologue
incorrectly refers to output_directory instead of input_directory.
---
 src/bin/pg_combinebackup/pg_combinebackup.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/src/bin/pg_combinebackup/pg_combinebackup.c b/src/bin/pg_combinebackup/pg_combinebackup.c
index 4f8ba156336..7544c6b33ee 100644
--- a/src/bin/pg_combinebackup/pg_combinebackup.c
+++ b/src/bin/pg_combinebackup/pg_combinebackup.c
@@ -826,7 +826,7 @@ parse_oid(char *s, Oid *result)
  *
  * n_prior_backups is the number of prior backups that we have available.
  * This doesn't count the very last backup, which is referenced by
- * output_directory, just the older ones. prior_backup_dirs is an array of
+ * input_directory, just the older ones. prior_backup_dirs is an array of
  * the locations of those previous backups.
  */
 static void
-- 
2.43.5